
type filename = string
type dim = { width : int ; height : int }

type glyph =
  | Char of char
  | Picture of dim*filename
  | HBox of glyph list ref
  | VBox of glyph list ref

let rec intersects glyph x y =
  match glyph with
    | Char c -> (* STUB *) assert false
    | Picture ({width;height},p) ->
        0 <= x && x <= width &&
        0 <= y && y <= height
    | HBox r | VBox r ->
        List.exists (fun g -> intersects g x y) !r

exception Not_a_composite

let get_child container i =
  match container with
    | Char _ | Picture _ -> raise Not_a_composite
    | HBox r | VBox r -> List.nth !r i

let add_child container g =
  match container with
    | Char _ | Picture _ -> raise Not_a_composite
    | HBox r | VBox r -> r := g :: !r
