#include <iostream>
#include <vector>
#include <string>

class Window {
  public:
    Window();
};

Window::Window() {}

class Point {
  // EMPTY
};

#include "glyph_safe.h"

/* Implementation of Glyph::Char */

Glyph::Char::Char(char c) {
  this->c = c;
}

void Glyph::Char::draw(Window* w) {
  std::cout << c;
}

bool Glyph::Char::intersects(Point* p) {
  return false; // STUB
}

/* Implementation of Glyph::HBox */

Glyph::HBox::HBox() {
}

void Glyph::HBox::draw(Window* w) {
  std::cout << '[';
  for (int i=0; i<children.size(); i++) {
    children[i]->draw(w);
  }
  std::cout << ']';
}

bool Glyph::HBox::intersects(Point* p) {
  return false; // STUB
}

void Glyph::HBox::addChild(Glyph* g) {
  children.push_back(g);
}

Glyph::Glyph* Glyph::HBox::getChild(int i) {
  return children[i];
}

/* Test */

Glyph::Glyph* getAndDuplicate(Glyph::Glyph* g) {
  Glyph::CompositeGlyph* c = dynamic_cast<Glyph::CompositeGlyph*>(g);
  if (c) {
    c->addChild(c->getChild(0));
    return c->getChild(0);
  } else {
    throw "Not a composite!";
  }
}

int main() {
  Window* w = new Window;

  Glyph::HBox* box = new Glyph::HBox();
  box->addChild(new Glyph::Char('x'));

  box->draw(w);
  std::cout << std::endl;

  Glyph::Glyph* g = getAndDuplicate(box);

  box->draw(w);
  std::cout << std::endl;

  std::cout << "Banzai!\n" << std::endl;
  getAndDuplicate(g);
  std::cout << "?!" << std::endl;
}
